:- multifile op/4.
:- dynamic op/4.

/*
op(OpName, ParameterList, Preconditions, Effects)
-----------------------------------------------------
*/
op(moveRight, [Id, X, Y, Length, NewPosX, DestinationX ],
   [vehicle(Id, pos(X,Y)),
    orientation(Id, horizontal),
    length(Id, Length),
    assign(DestinationX, X + Length),
    assign(NewPosX, X + 1),
    inPuzzle(pos(DestinationX, Y)),
    clear(pos(DestinationX, Y))],
   [not(vehicle(Id, pos(X,Y))),
    vehicle(Id, pos(NewPosX,Y))]).
    
op(moveLeft, [Id, X, Y, NewPosX],
   [vehicle(Id, pos(X,Y)),
    orientation(Id, horizontal),
    assign(NewPosX, X - 1),
    inPuzzle(pos(NewPosX, Y)),
    clear(pos(NewPosX, Y))],
   [not(vehicle(Id, pos(X,Y))),
    vehicle(Id, pos(NewPosX,Y))]).

op(moveDown, [Id, X, Y, Length, DestinationY, NewPosY],
   [vehicle(Id, pos(X,Y)),
    orientation(Id, vertical),
    length(Id, Length),
    assign(DestinationY, Y + Length),
    assign(NewPosY, Y + 1),
    inPuzzle(pos(X, DestinationY)),
    clear(pos(X, DestinationY))],
   [not(vehicle(Id, pos(X,Y))),
    vehicle(Id, pos(X, NewPosY))]).

op(moveUp, [Id, X, Y, NewPosY],
   [vehicle(Id, pos(X,Y)),
    orientation(Id, vertical),
    assign(NewPosY, Y - 1),
    inPuzzle(pos(X, NewPosY)),
    clear(pos(X, NewPosY))],
   [not(vehicle(Id, pos(X,Y))),
    vehicle(Id, pos(X, NewPosY))]).




/* all operators cost 1 */
:- multifile cost/3.
:- dynamic cost/3.
%% remove all other cost info
:- retractall(cost(_,_,_)).
%% cost info for these operators
cost(_, _, 1).  